#!/bin/csh
#Shijun Zhong, 2007
#   To generate the protein surface and the spheres
#   you need to install DMS and DOCK (by searching "UCSF DOCK" online)

set pdb = protein.pdb
set dms = ../bin/dms
set sphgen = ../bin/sphgen

if ( $#argv == 3 ) then
set pdb = $1
set dms = $2
set sphgen = $3
endif

rm -f pdbid.dms
$dms $pdb          -a -d 0.5 -n -g dms.log -o pdbid.dms

rm -f pdbid.sph OUTSPH
echo "pdbid.dms" > INSPH
echo "R" >> INSPH
echo "X" >> INSPH
echo "-0.5" >> INSPH
echo "4.0" >> INSPH
echo "1.4" >> INSPH
echo "pdbid.sph" >> INSPH
$sphgen

rm -f dms.log INSPH OUTSPH

