#!/bin/csh

#Shijun Zhong, July, 2007
#    Pick up top clusters from the CHARMM-reclustered sets
 setenv LC_ALL C

set PDBID = pdbid

set TOP   = 10
set showbox = ../bin/showbox
if ( $#argv == 2 ) then
set TOP = $1
set showbox = $2
endif

###############################################
#----prepare cluster centers in clustst.cst
###############################################
set FILE = clustst.cst
set head = 17
set cnt  = `wc -l $FILE | awk '{print $1}' `
set row  = ` expr $cnt - $head `
echo "$row centers"
tail -$row $FILE > tmppdb
echo "REMARK    The centers of sphere clusters generated by sphgen" > cluster_center.pdb
awk '{printf"%-6s%5d  %-3s %-4s%5d%12.3f%8.3f%8.3f\n","ATOM",$1,"C","SPH",$1,$6,$7,$8}' tmppdb >> cluster_center.pdb
echo "END" >> cluster_center.pdb
#12345678901234567890123456789012345678901234567890123456789012345678901234567890
#ATOM      3  C   SPH     3      16.613  21.239  -9.626
#       1       5       8 0.135E+01 0.165E+01     16.890   18.815  -10.276
awk '{printf"%5d%5d%12.3f%8.3f%8.3f%8.3f\n",$1,$2,$4,$5,$4*50/$2,$5*50/$2}' tmppdb > cluster_center.hist
rm -f tmppdb
       

######################################################
#-pick up top clusters
# Column 1 of clustst.member is the cluster number.
# Column 2 of cluster_center.hist
######################################################
 set FILE = clustst.member
 set head = 8
 set cnt  = `wc -l $FILE | awk '{print $1}' `
 set row  = ` expr $cnt - $head `
 tail -$row $FILE | sort -n -k 1 > tmpid
 grep "ATOM  " ${PDBID}_cut.sph.pdb > tmppdb

sort -nr -k 2 cluster_center.hist | head -$TOP | awk '{print $1}' > top_sets.id

if ( -d top_clust ) then
rm -rf top_clust
endif
mkdir top_clust
set i = 1
while ( $i <= $TOP )
set ID = ` head -$i top_sets.id | tail -1 `
echo "awk '{if(ZZZ1==$ID) print ZZZ2}' tmpid | sort -n -k 1 > top_clust/sph_set_$ID.id" > one
sed 's/ZZZ/$/g' one > two
source two

echo "REMARK    sphere set $ID for ${PDBID}" > top_clust/${PDBID}_clust_$i.pdb
set k = 1
set setnum = `wc -l top_clust/sph_set_$ID.id | awk '{print $1}' `
while ( $k <= $setnum )
set sphrow = ` head -$k top_clust/sph_set_$ID.id | tail -1 `
head -$sphrow tmppdb | tail -1 >> top_clust/${PDBID}_clust_$i.pdb
@ k++
end

@ i++
end

endif

#rm -f tmppdb tmpid one two cluster_center.pdb cluster_center.hist top_sets.id
rm -f tmppdb tmpid one two

cd top_clust
rm -f *.id
set i = 1
while ( $i <= $TOP )
awk '{if($1=="ATOM") print $6,$7,$8,$10,$11}' ${PDBID}_clust_$i.pdb > tmp
set NUMBER = `wc -l tmp | awk '{print $1}'`
echo "DOCK 3.5 receptor_spheres" > ${PDBID}_clust_$i.sph
echo "$i $NUMBER" > one
awk '{printf"cluster %5s   number of spheres in cluster %5d\n",$1,$2}' one >> ${PDBID}_clust_$i.sph
awk 'BEGIN{a=0} {a=a+1; printf"%5d%10.5f%10.5f%10.5f%8.3f%5d 0  0\n",a,$1,$2,$3,1.4,1}' tmp >> ${PDBID}_clust_$i.sph
echo "y" > one
echo "15" >> one
echo "${PDBID}_clust_$i.sph" >> one
echo "$i" >> one
echo "${PDBID}_box_$i.pdb" >> one
../$showbox < one
@ i++
end
rm -f one tmp
cd ..

