#!/bin/csh

#Shijun Zhong, 2007
#---To do test dockings against the selected binding sites.

set grid = ../bin/grid
set dock = ../bin/dock
set ligand = ligand1000.mol2
set mol2 = protein.mol2
set TOP = 10
  if ( $#argv == 5 ) then
set grid = $1
set dock = $2
set ligand = $3
set mol2 = $4
set TOP = $5
  endif

#---The default settings in ../parameter/grid.in
set BOXPDB = pdbid_box_1.pdb
set GRIDPREFIX = pdbid_grid_1
set PROTMOL2 = pdbid.mol2

#---The default settings in ../parameter/dock.in
set CLUSTSPH = pdbid_clust_1.sph
set LIGMOL2 = ligand1000.mol2
set DOCKPREFIX = pdbid_dock_1
set GRDPNT = 3456789

set PDBID = pdbid
set DIR = top_clust

set i = 1
while ( $i <= $TOP )

set BOX = ${PDBID}_box_$i.pdb
set GRD = ${PDBID}_grid_$i
echo "sed 's/$GRIDPREFIX/$GRD/g' ../parameter/grid.in > tmp" > one
echo "sed 's/$BOXPDB/$BOX/g' tmp > tmp2" >> one
echo "sed 's/$PROTMOL2/$mol2/g' tmp2 > grid.in" >> one
source one 
 $grid -i grid.in -o grid.ou

grep "Total number of grid points" grid.ou > one
set GRIDNUM = `awk '{print $7}' one`
set SPH = ${PDBID}_clust_$i.sph
set DCK = ${PDBID}_dock_$i

echo "sed 's/$GRIDPREFIX/$GRD/g' ../parameter/dock.in > tmp" > one
echo "sed 's/$DOCKPREFIX/$DCK/g' tmp > tmp2" >> one
echo "sed 's/$LIGMOL2/$ligand/g' tmp2 > tmp" >> one
echo "sed 's/$CLUSTSPH/$SPH/g' tmp > tmp2" >> one
echo "sed 's/$GRDPNT/$GRIDNUM/g' tmp2 > dock_$i.in" >> one
source one 
 $dock -i dock_$i.in -o dock_$i.ou

#---To clean up
mv ${PDBID}_dock_$i.mol2 $DIR
rm -f ${PDBID}_dock_$i.rst
if ( -d ref ) then
  mv dock_$i.in dock_$i.ou ${PDBID}_dock_$i.info ref
else
  mkdir ref
  mv dock_$i.in dock_$i.ou ${PDBID}_dock_$i.info ref
endif
rm -f $GRD.bmp $GRD.cnt $GRD.chm $GRD.nrg
rm -f tmp tmp2 one grid.in grid.ou

@ i++
end

