#!/bin/csh
#Shijun Zhong, September 10, 2006
#---This script converts *.sph to *.crd and *.pdb
#   The *.sph is a single cluster reorganized from the output of sphgen
#Usage: sph2crd.csh   single_cluster.sph
#Output: single_cluster.crd
#        single_cluster.pdb
#        single_cluster.xyz
#

set sph = $1
set name = $sph
#set name = `echo $sph | sed s/\.sph//`

set NUMBER = ` wc -l $sph | awk '{print $1}' `
set NUMBER = ` expr $NUMBER - 2 `
tail -$NUMBER $sph > tmp.sph
echo "* converted from $sph" > $name.crd
echo "*" >> $name.crd
echo "$NUMBER" > tmp
awk '{printf"%5d\n",$1}' tmp >> $name.crd
#    1 -29.64216 -13.93322  -2.06517   1.444   14 0  0   #sph input
#    1    1 SPH  C    -34.93900  -7.12900   1.78300 MAIN 6      0.00000  #crd output
awk 'BEGIN{a=0} {a=a+1;printf"%5d%5d SPH  C   %10.5f%10.5f%10.5f MAIN %-5d%9.5f\n",a,a,$2,$3,$4,$1,$5}' tmp.sph >> $name.crd

echo "REMARK    converted from $sph" > $name.pdb
echo "REMARK    $NUMBER" >> $name.pdb
#ATOM      7  C   SPH    13     -29.133  -9.908  -2.974  1.00  0.60      MAIN   #pdb output
awk 'BEGIN{a=0} {a=a+1;printf"ATOM  %5d  C   SPH %5d    %8.3f%8.3f%8.3f%6.2f%6.2f      MAIN\n",a,a,$2,$3,$4,1,$5}' tmp.sph >> $name.pdb

awk '{print $2,$3,$4}' tmp.sph > $name.xyz

rm -f tmp.sph tmp

