#!/usr/bin/perl 
###!/usr/bin/perl -w

# Shijun Zhong, 8/28/2006.
# This program cuts SPHGEN-generated sph file into two parts
# One is the clustered, another the entire set, i.e. cluster #0
# Usage: sph_cut.pl pdbid.sph

#$[ = 1;                 # set array base to 1
$/ = "\n";              # set input record separator
$, = ' ';               # set output field separator
$\ = "\n";              # set output record separator

($#ARGV == 0) or die "Usage: sph_cut.pl pdbid.sph\n";

open (SPH, $ARGV[0]) or die "$ARGV[0]:$!";
open (SPH0, ">pdbid_0.sph") or die "pdbid_0.sph:$!";
open (CLUSTER, ">pdbid_cut.sph") or die "pdbid_cut.sph:$!";
open (TMP, ">tmp.sph") or die "tmp.sph:$!";
$total = 0;

while (<SPH>) {
       $getsph = $_;
       @F = split(' ',$getsph,999);
       $head = $F[0];
       $ncluster = $F[1];
       $nsph = $F[7];
#            printf "%10s%10d%10d\n",$head,$ncluster,$nsph;
       if ($head eq "DOCK") {
           printf SPH0    "%s",$getsph;
           printf CLUSTER "%s",$getsph;
       }
   if ($head eq  "cluster") {
#         printf "%6d\n",$ncluster;
#         printf "%6d\n",$nsph;
     if ($ncluster == 0) {
       printf SPH0 "%7s%6d   %28s%6d\n","cluster",$ncluster,"number of spheres in cluster",$nsph;
       for ($i=1; $i<=$nsph; $i++) {
       $getsph = <SPH>;
       printf SPH0    "%s",$getsph;
       }
     } 
     else {
       $total = $total + $nsph;
#          printf "%5d  %20s\n", $total,$getsph;
       for ($i=1; $i<=$nsph; $i++) {
       $getsph = <SPH>;
       printf TMP     "%s",$getsph;
       }
     } 
   }
}

printf CLUSTER "%7s%6d   %28s%6d\n","cluster",99,"number of spheres in cluster",$total;
close (CLUSTER) || die "can't close SPH \n";
close (TMP) || die "can't close SPH \n";
close (SPH0) || die "can't close SPH \n";
close (SPH) || die "can't close SPH \n";
#system ("cat tmp.sph >> pdbid_cut.sph");
system ("sort -n -k 1 tmp.sph >> pdbid_cut.sph");
#unlink "pdbid_0.sph";
unlink "tmp.sph";

